CAPH_FUN:
    ;CapOutH
    BSF		GPIO, CAP_PIN
    BCF		tris_reg, CAP_PIN
    MOVF	tris_reg,W
    TRIS	GPIO
    RETLW	0

FAN_REG_LAB: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    CALL	CAPH_FUN
    BTFSC	state_reg, ALARM_ON		    ; if alarm set fan full 
    GOTO	FAN_REG_LAB_end
    JG		temp, (2 * tfmax), FAN_REG_LAB_end  ; jump if temp > tfmax
    CapOutL
    
FAN_REG_LAB_cont:
    MOVF	temp,W				    ; tcharge = temp - (tmin * 2)
    MOVWF	tcharge
    MOVLW	(2 * tfmin)
    SUBWF	tcharge,F

discharging_procedure: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    DelayUs	500				    ; wait for discharge C
charging_procedure: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    CALL	CAPH_FUN
    DelayUs	800				    ; pre charging
    GOTO	charging_delay
charging_delay_ret:    
wait_caphiz:    
    CapOutHZ
    ;DelayUs	333329
    GOTO	FAN_REG_LAB_end
charging_pre_delay: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
charging_delay: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    CLRF	cnt2
    CLRF	cnt1
    CLRF	tmp0
cd2:
    MOVF	cnt2,F		; check if cnt2 == 0
    BTFSS	STATUS,Z	; if zero jump
    GOTO	cd3
    RLF		cnt1,F
    INCF	cnt1,F		; cnt1 = (2^d) - 1
    MOVLW	10		; cnt2 = 10
    MOVWF	cnt2
cd3:    
    MOVF	cnt1,W
    MOVWF	tmp0
cd4:
    GOTO	$+1
    GOTO	$+1
    GOTO	$+1
    DECFSZ	tmp0,F
    GOTO	cd4
    DECF	cnt2,F
    MOVF	tcharge,F	; check if tcharge == 0
    BTFSC	STATUS,Z	; if not zero skip next
    GOTO	charging_delay_ret	; if zero return
    DECF	tcharge,F	; tcharge--
    GOTO	cd2		; while condition

#ifdef MEASURE    
fan_measure: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    CLRWDT
    MOVLW	gpio_masq | b'00001000'
    TRIS	GPIO
    CLRWDT
    MOVLW	optreg | b'00000100'
    OPTION        
    
    MOVLW	.1
    MOVWF	TMR0    
wait_fan_low:
    MOVLW	.255
    SUBWF	TMR0,0
    BTFSC	STATUS,Z
    GOTO	tmr0_ovf
    BTFSS       GPIO,FANMEASURE_PIN	
    GOTO	wait_fan_low
    MOVLW	.1
    MOVWF	TMR0    
wait_fan_high:    
    MOVLW	.255
    SUBWF	TMR0,0
    BTFSC	STATUS,Z
    GOTO	tmr0_ovf    
    BTFSC       GPIO,FANMEASURE_PIN	
    GOTO	wait_fan_high
    CLRF	TMR0
wait_fan_low_1:
    MOVLW	.255
    SUBWF	TMR0,0
    BTFSC	STATUS,Z
    GOTO	tmr0_ovf
    BTFSS       GPIO,FANMEASURE_PIN	
    GOTO	wait_fan_low_1
tmr0_ovf:    
    MOVF	TMR0,0
    MOVWF	fsreg
fan_measure_end_proc:    
    GOTO	fan_measure_end
#endif